# config check

## 介绍

该工具主要适用于对比两个环境下可能影响训练精度的配置差异，支持mindspore和pytorch两个框架，包括：

- 环境变量
- 三方库版本
- 训练超参
- 权重
- 数据集
- 随机操作


## 安装教程

参见 msprobe [安装教程](./01.installation.md)

## 使用说明

用户需要在两个待比对的训练的环境上分别进行数据采集, 工具会采集两个环境下影响精度的配置，采集结果上传到同一机器进行比对。

### 数据采集

#### 静态数据采集

静态数据采集仅支持环境变量，三方库版本及训练超参采集，其中环境变量，三方库版本默认采集，训练超参采集需要用户传入启动训练的 shell 脚本路径或 yaml 配置文件，
支持多个输入，不传入表示不采集。

启动命令如下
```shell
msprobe -f pytorch/mindspore config_check -d **.sh **.yaml -o output_path
```
-f 代表训练框架，传入pytorch或mindspore，必选。

-d 代表数据采集模式，可传入启动训练的 shell 脚本路径或 yaml 配置文件路径，可选，不传入代表不采集。

-o 代表输出路径，可选，默认为 config_check_pack.zip。

#### 动态数据采集


在训练流程执行到的第一个python脚本开始处插入如下代码：
```
from msprobe.core.config_check import ConfigChecker
ConfigChecker.apply_patches(fmk)
```

说明：

- fmk：训练框架。可选 pytorch 和 mindspore ，不传默认为 pytorch。

在模型初始化好之后插入如下代码：
```
from msprobe.core.config_check import ConfigChecker
ConfigChecker(model, shell_path, output_zip_path, fmk)
```

说明：

- model：初始化好的模型。不传或缺省就不会采集权重和数据集。
- shell_path：动态采集模式下支持 **megatron** 训练超参自动捕获，使用 **megatron** 时推荐不传入，其他情况下可传入训练脚本路径，类型为列表，传入一个或多个训练配置/启动脚本。不传或缺省就不会采集超参。
- output_zip_path：输出zip包的路径，不传默认为"./config_check_pack.zip"。
- fmk：当前是什么框架。可选 pytorch 和 mindspore ，不传默认为 pytorch。

采集完成后会得到一个zip包，里面包括各项[影响精度的配置](#介绍)。会分rank和step存储，其中step为micro_step。

在另一个环境上执行上述操作，得到另一个zip包

### 数据比对

将两个zip包传到同一个环境下，使用如下命令进行比对：

```shell
msprobe -f pytorch config_check -c bench_zip_path cmp_zip_path -o output_path
```

其中**bench_zip_path** 为标杆侧采集到的数据， **cmp_zip_path** 为待对比侧采集到的数据。

**output_path 会被删掉再新建**，不传默认为"./config_check_result"， 在 **output_path** 里会生成2个目录和1个文件：
- bench：bench_zip_path里打包的数据。
- cmp：cmp_zip_path里打包的数据。
- result.xlsx：比对结果。里面会有多个sheet页，其中**summary**总览通过情况，其余页是具体检查项的详情。其中step为micro_step。

## 通过标准

以下五项检查通过：

- 环境变量
- 三方库版本
- 训练超参
- 权重
- 数据集

这五项检查在**精度比对**前必须保证达成。
